ALTER FUNCTION [dbo].[Guthabenvorbereitung] 
(
    @InstNR nvarchar(3),
    @BDate datetime
)
RETURNS TABLE
AS
RETURN
(	
SELECT     tab_KNE_KN.KNEID, tab_KNE_KN.KNID,  tab_KNE_KN.GBR_Quote,  
           MIN(ISNULL(tabKreditnehmer.kn_passiv_az2_3_4_9, 0) + ISNULL(tabKreditnehmer.kn_passiv_depot, 0)) AS KN_Passiv_Gesamt, 
           SUM(CASE WHEN tabKonto.kto_saldo > 0 THEN tabKonto.kto_saldo ELSE 0 END) AS PositiverSaldo  
FROM       tab_KNE_KN INNER JOIN
           tabKreditnehmer ON tab_KNE_KN.KNID = tabKreditnehmer.KNID left JOIN
           tabKonto ON tabKreditnehmer.KNID = tabKonto.KNID
WHERE     (tab_KNE_KN.INR = @INSTNR) AND (tab_KNE_KN.Bdate = @BDate)
GROUP BY tab_KNE_KN.KNEID, tab_KNE_KN.KNID,  tab_KNE_KN.GBR_Quote 
)
GO
Delete from stabfilter where FID > 7
GO


Update stabfilter set INR = 0, BDate = '01.01.1900', SPID = 0 where FID <8
GO 

/* berprfen Sie das Skript grndlich, bevor Sie es auerhalb des Datenbank-Designer-Kontexts ausfhren, um potenzielle Datenverluste zu vermeiden.*/
BEGIN TRANSACTION
SET QUOTED_IDENTIFIER ON
SET ARITHABORT ON
SET NUMERIC_ROUNDABORT OFF
SET CONCAT_NULL_YIELDS_NULL ON
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
COMMIT
BEGIN TRANSACTION
GO
ALTER TABLE dbo.stabFilter
	DROP CONSTRAINT DF_stabFilter_Aktiv
GO
ALTER TABLE dbo.stabFilter
	DROP CONSTRAINT DF_stabFilter_EWBFilter
GO
CREATE TABLE dbo.Tmp_stabFilter
	(
	FID int NOT NULL,
	SPID int NOT NULL,
	INR nvarchar(3) NOT NULL,
	BDate datetime NOT NULL,
	Filtername nvarchar(255) NULL,
	Filterkriterien ntext NULL,
	Aktiv bit NOT NULL,
	EWBFilter bit NOT NULL,
	TS timestamp NOT NULL
	)  ON [PRIMARY]
	 TEXTIMAGE_ON [PRIMARY]
GO
ALTER TABLE dbo.Tmp_stabFilter SET (LOCK_ESCALATION = TABLE)
GO
ALTER TABLE dbo.Tmp_stabFilter ADD CONSTRAINT
	DF_stabFilter_Aktiv DEFAULT ((1)) FOR Aktiv
GO
ALTER TABLE dbo.Tmp_stabFilter ADD CONSTRAINT
	DF_stabFilter_EWBFilter DEFAULT ((0)) FOR EWBFilter
GO
IF EXISTS(SELECT * FROM dbo.stabFilter)
	 EXEC('INSERT INTO dbo.Tmp_stabFilter (FID, SPID, INR, BDate, Filtername, Filterkriterien, Aktiv, EWBFilter)
		SELECT FID, SPID, INR, BDate, Filtername, Filterkriterien, Aktiv, EWBFilter FROM dbo.stabFilter WITH (HOLDLOCK TABLOCKX)')
GO
DROP TABLE dbo.stabFilter
GO
EXECUTE sp_rename N'dbo.Tmp_stabFilter', N'stabFilter', 'OBJECT' 
GO
ALTER TABLE dbo.stabFilter ADD CONSTRAINT
	PK_stabFilter_1 PRIMARY KEY CLUSTERED 
	(
	FID,
	SPID,
	INR,
	BDate
	) WITH( STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO
COMMIT
select Has_Perms_By_Name(N'dbo.stabFilter', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.stabFilter', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.stabFilter', 'Object', 'CONTROL') as Contr_Per 

GO

ALTER PROCEDURE [dbo].[spManuelleFilterRaus] 
    @InstNR nvarchar(3),
    @BDate datetime,
	@SPID int
AS
BEGIN
	SET NOCOUNT ON;
-- Insert statements for procedure here
SELECT F.FID, F.Filtername, F.Filterkriterien, F.EWBFilter
FROM stabFilter AS F
WHERE cast(F.Filterkriterien as nvarchar(max))='Manuell entfernt' AND F.EWBFilter=0  
      AND ((INR = @Instnr and Bdate = @Bdate and (SPID = @SPID OR SPID = 0)) OR (INR = 0 and BDATE = '01.01.1900'))
	  ORDER BY F.FID;
END
GO

ALTER PROCEDURE [dbo].[spManuelleFilterRausEWB] 
    @InstNR nvarchar(3),
    @BDate datetime,
	@SPID int
AS
BEGIN
	SET NOCOUNT ON;
-- Insert statements for procedure here
SELECT F.FID, F.Filtername, F.Filterkriterien, F.EWBFilter
FROM stabFilter AS F
WHERE cast(F.Filterkriterien as nvarchar(max))='Manuell entfernt' AND F.EWBFilter=1  
      AND ((INR = @Instnr and Bdate = @Bdate and (SPID = @SPID OR SPID = 0)) OR (INR = 0 and BDATE = '01.01.1900'))
ORDER BY F.FID;
END
GO

ALTER PROCEDURE [dbo].[spManuelleFilterRein] 
    @InstNR nvarchar(3),
    @BDate datetime,
	@SPID int
AS
BEGIN
	SET NOCOUNT ON;
-- Insert statements for procedure here
SELECT F.FID, F.Filtername, F.Filterkriterien, F.EWBFilter
FROM stabFilter AS F
WHERE cast(F.Filterkriterien as nvarchar(max))='Manuell ausgewhlt' AND F.EWBFilter=0  
      AND ((INR = @Instnr and Bdate = @Bdate and (SPID = @SPID OR SPID = 0)) OR (INR = 0 and BDATE = '01.01.1900'))
ORDER BY F.FID;
END
GO

ALTER PROCEDURE [dbo].[spManuelleFilterReinEWB] 
    @InstNR nvarchar(3),
    @BDate datetime,
	@SPID INT
AS
BEGIN
	SET NOCOUNT ON;
-- Insert statements for procedure here
SELECT F.FID, F.Filtername, F.Filterkriterien, F.EWBFilter
FROM stabFilter AS F
WHERE cast(F.Filterkriterien as nvarchar(max))='Manuell ausgewhlt' AND F.EWBFilter=1  
      AND ((INR = @Instnr and Bdate = @Bdate and (SPID = @SPID OR SPID = 0)) OR (INR = 0 and BDATE = '01.01.1900'))
ORDER BY F.FID;
END
GO


ALTER PROCEDURE [dbo].[spLadenFilter] 
    @AuswahlID int,
	@SPID int
AS
BEGIN
	SET NOCOUNT ON;
INSERT INTO tabFilter
            (SPID, FID, Filtername, Filterkriterien, Aktiv, EWBFilter, INR, LastFilter, BDate)
SELECT       @SPID, FID, Filtername, Filterkriterien, Aktiv, EWBFilter, INR, LastFilter, BDate
FROM         sichernFilter
WHERE       AuswahlID = @AuswahlID 

INSERT INTO stabFilter
            (FID, Filtername, Filterkriterien, Aktiv, EWBFilter, INR,  BDate, SPID)
SELECT       FID, Filtername, Filterkriterien, Aktiv, EWBFilter, INR,  BDate, @SPID
FROM         sichernManuelleFilter
WHERE       AuswahlID = @AuswahlID
       
END
GO

Update _tabVersion set DBVersion = '7.80', DBDate = '13.11.2018'
GO